/*

  Can Bus MCP2515 (Reciever)

  Parts required:
  - Arduino Board
  - Can Bus MCP2515

  Programming by : René Rasmussen
  Website : www.it-teknolog.dk
  Contact : renerasmussen@it-teknolog.dk
  Date : 15 Sep 2020
  Version : v1.0

  Modulet kan købes på www.arduinotech.dk

*/

#include <SPI.h>                                            // include library SPI
#include <mcp2515.h>                                        // include library mcp2515

struct can_frame canMsg;
MCP2515 mcp2515(10);                                        // Set the pin number where SPI CS is connected (10 by default)

void setup() {
  SPI.begin();                                              // start SPI
  Serial.begin(9600);                                       // start Serial Communication
  mcp2515.reset();                                          // reset the Can Bus MCP2515
  mcp2515.setBitrate(CAN_50KBPS, MCP_8MHZ);                 // set bit rate to 50KBps and internal clock to 8MHz
  mcp2515.setNormalMode();                                  // set mode
  Serial.println("MCP Started...");                         // print text to Serial Monitor
  Serial.println("");                                       // print new line Serial Monitor
}

void loop() {
  if ((mcp2515.readMessage(&canMsg) == MCP2515::ERROR_OK) && (canMsg.can_id == 0x036)) {     // read message from Can Bus

    Serial.println("Data Received...");                     // print text to Serial Monitor
    Serial.println("----------------");                     // print text to Serial Monitor

    //    for (int counter = 0; counter <= 7; counter++) {
    //      int dataReceived = canMsg.data[counter];
    //      Serial.print(dataReceived);
    //      if (counter <= 6) {
    //        Serial.print(" - ");
    //      }
    //    }

    for (int counter = 0; counter <= 7; counter++) {        // for counter = 0 to 7 do
      int dataReceived = canMsg.data[counter];              // set variable dataReceived to can bus data bit 0-7
      Serial.print("Bit ");                                 // print text to Serial Monitor
      Serial.print(counter);                                // print counter number to Serial Monitor
      Serial.print(" - ");                                  // print text to Serial Monitor
      Serial.print(dataReceived);                           // print can bus data bit number 0-7
      Serial.println("");                                   // print new line Serial Monitor

    }
    Serial.println("");                                     // print new line Serial Monitor                              
    Serial.println("");                                     // print new line Serial Monitor
  }
}
