/*

  Can Bus MCP2515 (Reciever)

  Parts required:
  - Arduino Board
  - Can Bus MCP2515

  Programming by : René Rasmussen
  Website : www.it-teknolog.dk
  Contact : renerasmussen@it-teknolog.dk
  Date : 10 Sep 2020
  Version : v1.0

  Modulet kan købes på www.arduinotech.dk

*/

#include <SPI.h>                            // include library SPI
#include <mcp2515.h>                        // include library mcp2515

struct can_frame canMsg; 
MCP2515 mcp2515(10);                        // Set the pin number where SPI CS is connected (10 by default)

void setup() {
  SPI.begin();                              // start SPI
  Serial.begin(9600);                       // start Serial Communication
  mcp2515.reset();                          // reset the Can Bus MCP2515                
  mcp2515.setBitrate(CAN_50KBPS,MCP_8MHZ);  // set bit rate to 50KBps and internal clock to 8MHz
  mcp2515.setNormalMode();                  // set mode
  Serial.println("MCP Started...");
}

void loop(){
 if ((mcp2515.readMessage(&canMsg) == MCP2515::ERROR_OK) && (canMsg.can_id == 0x036)){      // read message from Can Bus
     int x = canMsg.data[0];                // store data in variable x
     Serial.print("Data Recieved: ");       // print text to Serial Monitor
     Serial.println(canMsg.data[0]);        // print data to Serial Monitor
   }
}
